import string
import Numeric
def AsciiMatrixReader(filename):

   """
	def function_name(filename):

	 reads a file containing an ascii matrix.
         Carriage return split lines
	EXAMPLE (MLAB):

a=MLab.AsciiReader("toto.txt")

        

   """  

   f=open(filename,"r")
   datas=f.read()
   datalines=string.split(datas,"\n")

   Np=len(datalines)

   data=map(string.split,datalines)

   dim=len(data[0])
   for i in range(Np):
     data[i]=map(string.atof,data[i])

   newdata=[]
   for i in range(Np):
     if(len(data[i])==dim):
         newdata.append(data[i])
   data=Numeric.array(newdata)


   return data


def AsciiMatrixWriter(A, filename, format="%s"):
   """
	def function_name(A,filename, format="%s"):
	 - A is a numPy matrix
        
	 write a matrix in ascii format a file containing an ascii matrix.
         Carriage return split lines

	 The format argument, if specified, will be used 
           in this context ( writing to file) :
                f.fwrite( format % token  )
             
	EXAMPLE (MLAB):


import Numeric
import math
A=Numeric.arrayrange(0,10,math.sqrt(2.0))
MLab.AsciiWriter(A,"toto.txt", "%10.10e")
B=MLab.AsciiReader("toto.txt")
print B -A    
       

   """  

   if(len(A.shape)==1):
	   f=open(filename,"w")
	   for tok in A:
              f.write(format % tok)
              f.write(" ")
           f.close()
   elif(    len(A.shape)==2):
	   f=open(filename,"w")
	   for Al in A:
		   for tok in Al:
        	      f.write(format % tok)
        	      f.write(" ")
                   f.write("\n")
           f.close()
   else:
           raise "  wrong shape for object A in routine AsciiMatrixWriter"

 


