#!/usr/bin/env python

"""Setup script for the SPS module distribution."""

import os, sys, glob
from distutils.core import setup
from distutils.extension import Extension

setup (
        name         = "sps",
        version      = "1.0",
        description  = "shared memory and spec",
        author       = "BLISS Group",
        author_email = "rey@esrf.fr",
        url          = "http://www.esrf.fr/computing/bliss/",

        # Description of the modules and packages in the distribution

        extra_path   = 'Pybliss',
        ext_modules  = [
                       Extension(
                            name = 'sps',
                            sources=['Src/sps.c',
                                     'Src/sps_py.c'],
                            include_dirs  = ['Include'],
                       ),
                       Extension(
                            name = 'spslut',
                            sources=['Src/sps_lut.c',
                                     'Src/spslut_py.c'],
                            include_dirs  = ['Include'],
                       ),
       ],
)
